
XIncludeFile "Container.pb"


Interface LinkList
  add.i(*element=#Null)
  delete.i()
  prevEl.i()
  nextEl.i()
  reset.i()
  get.i()
  size.i()
  clear.i()
  free.i()
EndInterface


Macro InitLinkList(_type_, _container_=List)
  DisableDebugger
  
  InitContainer(_type_, _container_)
  
  
  CompilerIf Not Defined(LinkList#_type_, #PB_Structure)
    
    Structure LinkList#_type_ Extends CNStructure(_type_, _container_)
    EndStructure
    
    
    ;- LinkList_add
    Procedure LinkList#_type_#_add(*this.LinkList#_type_, *element=#Null)
      Protected *res
      
      CNAdd(*res, _type_, _container_)
      
      If (*element <> #Null)
        CopyStructure(*element, *res, _type_)
      EndIf
      
      ProcedureReturn *res
    EndProcedure
    
    
    ;- LinkList_delete
    Procedure LinkList#_type_#_delete(*this.LinkList#_type_)
      CNDel(_type_, _container_)
    EndProcedure
    
    
    ;- LinkList_prevEl
    Procedure LinkList#_type_#_prevEl(*this.LinkList#_type_)
      Protected *res
      
      CNPrev(*res, _container_)
      
      ProcedureReturn *res
    EndProcedure
    
    
    ;- LinkList_nextEl
    Procedure LinkList#_type_#_nextEl(*this.LinkList#_type_)
      Protected *res
      
      CNNext(*res, _container_)
      
      ProcedureReturn *res
    EndProcedure
    
    
    ;- LinkList_reset
    Procedure LinkList#_type_#_reset(*this.LinkList#_type_)
      CNReset(_container_)
    EndProcedure
    
    
    ;- LinkList_get
    Procedure LinkList#_type_#_get(*this.LinkList#_type_)
      Protected *res
      
      CNGet(*res, _container_)
      
      ProcedureReturn *res
    EndProcedure
    
    
    ;- LinkList_size
    Procedure LinkList#_type_#_size(*this.LinkList#_type_)
      Protected size
      
      CNSize(size, _container_)
      
      ProcedureReturn size
    EndProcedure
    
    
    ;- LinkList_clear
    Procedure LinkList#_type_#_clear(*this.LinkList#_type_)
      CNClear(_type_, _container_)
    EndProcedure
    
    
    ;- LinkList_free
    Procedure LinkList#_type_#_free(*this.LinkList#_type_)
      FreeStructure(*this)
    EndProcedure
    
    
    ;- NewLinkList
    Procedure NewLinkList#_type_(*this.LinkList#_type_ = #Null)
      If (*this = #Null)
        *this = AllocateStructure(LinkList#_type_)
      EndIf
      *this\VTable = ?Functions
      
      DataSection
        Functions:
        Data.i @LinkList#_type_#_add()
        Data.i @LinkList#_type_#_delete()
        Data.i @LinkList#_type_#_prevEl()
        Data.i @LinkList#_type_#_nextEl()
        Data.i @LinkList#_type_#_reset()
        Data.i @LinkList#_type_#_get()
        Data.i @LinkList#_type_#_size()
        Data.i @LinkList#_type_#_clear()
        Data.i @LinkList#_type_#_free()
      EndDataSection
      
      ProcedureReturn *this
    EndProcedure
    
  CompilerEndIf
  
  EnableDebugger
EndMacro


Macro NewLinkList(_type_, _this_ = #Null)
  NewLinkList#_type_(_this_)
EndMacro


; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; Folding = -
; EnableXP