
XIncludeFile "Container.pb"


Interface Queue
  front.i()
  enqueue.i(*element=#Null)
  dequeue.i()
  isEmpty.i()
  clear.i()
  free.i()
EndInterface


Macro InitQueue(_type_, _container_=List)
  DisableDebugger
  
  InitContainer(_type_, _container_)
  
  
  CompilerIf Not Defined(Queue#_type_, #PB_Structure)
    
    Structure Queue#_type_ Extends CNStructure(_type_, _container_)
    EndStructure
    
    
    ;- Queue_front
    Procedure Queue#_type_#_front(*this.Queue#_type_)
      Protected *res
      
      CNGet(*res, _container_)
      
      ProcedureReturn *res
    EndProcedure
    
    
    ;- Queue_enqueue
    Procedure Queue#_type_#_enqueue(*this.Queue#_type_, *element=#Null)
      Protected *res
      
      CNReset(_container_)
      CNAdd(*res, _type_, _container_)
      
      If (*element <> #Null)
        CopyStructure(*element, *res, _type_)
      EndIf
      
      CNLast(_container_)
      
      ProcedureReturn *res
    EndProcedure
    
    
    ;- Queue_dequeue
    Procedure Queue#_type_#_dequeue(*this.Queue#_type_)
      CNDel(_type_, _container_)
    EndProcedure
    
    
    ;- Queue_isEmpty
    Procedure Queue#_type_#_isEmpty(*this.Queue#_type_)
      Protected size
      
      CNSize(size, _container_)
      
      ProcedureReturn Bool(size = 0)
    EndProcedure
    
    
    ;- Queue_clear
    Procedure Queue#_type_#_clear(*this.Queue#_type_)
      CNClear(_type_, _container_)
    EndProcedure
    
    
    ;- Queue_free
    Procedure Queue#_type_#_free(*this.Queue#_type_)
      FreeStructure(*this)
    EndProcedure
    
    
    ;- NewQueue
    Procedure NewQueue#_type_(*this.Queue#_type_ = #Null)
      If (*this = #Null)
        *this = AllocateStructure(Queue#_type_)
      EndIf
      *this\VTable = ?Functions
      
      DataSection
        Functions:
        Data.i @Queue#_type_#_front()
        Data.i @Queue#_type_#_enqueue()
        Data.i @Queue#_type_#_dequeue()
        Data.i @Queue#_type_#_isEmpty()
        Data.i @Queue#_type_#_clear()
        Data.i @Queue#_type_#_free()
      EndDataSection
      
      ProcedureReturn *this
    EndProcedure
    
  CompilerEndIf
  
  EnableDebugger
EndMacro


Macro NewQueue(_type_, _this_ = #Null)
  NewQueue#_type_(_this_)
EndMacro


; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; Folding = -
; EnableXP